#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include "main.h"
#include "Graphics.h"
#include "System.h"

#define SCREEN_WIDTH    640
#define SCREEN_HEIGHT   480

void circle(int centerX, int centerY, int radius, Color c)
{
    int x = 0;
    int y = radius;
    int m = 5 - 4 * radius;

    while (x <= y)
    {
        for (int xx = centerX - y; xx <= centerX + y; xx++)
        {
            gfx.setPixel(xx, centerY - x, c);
            gfx.setPixel(xx, centerY + x, c);
        }

        if (m > 0)
        {
            for (int xx = centerX - x; xx <= centerX + x; xx++)
            {
                gfx.setPixel(xx, centerY - y, c);
                gfx.setPixel(xx, centerY + y, c);
            }

            y--;
            m -= 8 * y;
        }

        x++;
        m += 8 * x + 4;
    }
}

int main(int argc, char* argv[])
{
    // init the window
    gfx.init("Bresenham circle 12", SCREEN_WIDTH, SCREEN_HEIGHT);
    gfx.init2D();
    gfx.clearScreen(Color(0, 0, 0, SDL_ALPHA_OPAQUE));

    // time 10000 circles
    sys.StartPerfCounter();

    for (int i = 0; i < 10000; i++)
        circle(SCREEN_WIDTH  / 2, SCREEN_HEIGHT / 2, 150, Color(255, 255, 255));

    printf("%f\n", sys.StopPerfCounter());

    // wait for the user to quit
    while (sys.isQuitRequested() == false)
    {
        gfx.render();
        sys.wait(20);
        sys.processEvents();
    }

    gfx.quit();

    return EXIT_SUCCESS;
}
